import React, { useState, useContext, useEffect } from 'react'
import { Card, Input, Label,Row, Col } from 'reactstrap'
import { ProductContext } from '../../context/products'
import { useRouter } from 'next/router'


export const Inventory = ({ update }) => {

    const [sku, setSku] = useState("")
    const [barcode, setBarcode] = useState("")
    const [available, setAvailable] = useState(0)
    const productContext = useContext(ProductContext)

    const router = useRouter()
    const productId = router.query
    

    useEffect(() => {

        if (update) {

            console.log(update)

        }

    }, [])

    useEffect(() => {

        productContext.dispatch({ 
            type: "updateProduct", 
            payload : { inventory : { sku, barcode, }}
        })
    }, [sku, barcode])

    return (
        <Card className="p-3 mt-4 mb-4">

            <h3> Inventory </h3>

            <div>
                <Row className="pt-2 pb-2"> 
                    <Col>
                        <Label>
                            SKU (Stock Keeping Unit)
                            <Input  
                                type="text"
                                value={sku}
                                onChange={e => setSku(e.target.value)}
                            />
                        </Label>
                    </Col>
                    
                    <Col>
                        <Label>
                            Barcode (ISBN, UPC, GTIN, etc.)
                            <Input  
                                type="text"
                                value={barcode}
                                onChange={e => setBarcode(e.target.value)}
                            />
                        </Label>
                    </Col>
                </Row>
                
                <Col className="ml-4 pb-2">
                    <Row>
                        <Label>
                            <Input type="checkbox"/>
                            Track quantity
                        </Label>
                    </Row>

                    <Row>
                        <Label>
                            <Input type="checkbox"/>
                            Continue selling when out of stock
                        </Label>
                    </Row>
                </Col>
            </div>

            <div style={{borderTop : "1px solid grey"}} className="pt-3">
                <h5> QUANTITY </h5>

                <Label className="pt-1">
                    Available
                    <Input  
                        type="text"
                        value={available}
                        onChange={e => setAvailable(e.target.value)}
                    />
                </Label>
            </div>
        </Card>
    )
}