import React, { useEffect, useState, useContext } from 'react'
import { Card, Input, Label } from 'reactstrap'
import { ProductContext } from '../../context/products' 
import { useRouter } from 'next/router'


export const Organization = ({ update }) => {

    const [productType, setProductType] = useState("")
    const [vendor, setVendor] = useState("")
    const [collections, setCollections] = useState("")
    const [tags, setTags] = useState("")
    const productContext = useContext(ProductContext)

    const router = useRouter()
    const productId = router.query


    useEffect(() => {

        if (update) {

            console.log(update)

        }

    }, [])

    useEffect(() => {

        productContext.dispatch({ 
            type: "updateProduct", 
            payload : {
                organization : { productType, collections, tags },
                vendor
            }
        })
    }, [productType, collections, tags, vendor])
  
    return (
        <Card className="p-3 mt-4 mb-4">

            <h3> Organization </h3>

            <Label className="pt-3">
                Product type
                <Input  
                    type="text"
                    value={productType}
                    onChange={e => setProductType(e.target.value)}
                />
            </Label>

            <Label className="pt-2 pb-2">
                Vendor
                <Input  
                    type="text"
                    value={vendor}
                    onChange={e => setVendor(e.target.value)}
                />
            </Label>

            <span style={{borderTop: "1px solid grey"}} className="pt-2"></span>

            <div className="pt-2 pb-3" style={{borderBottom: "1px solid grey"}}>

                <p> COLLECTIONS </p> 

                <Input  
                    type="text"
                    value={collections}
                    onChange={e => setCollections(e.target.value)}
                />

            </div>
            
            <div className="pt-3">
               
                <p> TAGS </p>
               
                <Input  
                    type="text"
                    value={tags}
                    onChange={e => setTags(e.target.value)}
                />
            </div>

        </Card>
    )
}