import React, { useState, useContext, useEffect } from 'react'
import { Card, Label, Input, Col, Container, Row, FormGroup } from 'reactstrap'
import { ProductContext } from '../../context/products' 
import { useRouter } from 'next/router'


export const Pricing = ({ update }) => {

    const [price, setPrice] = useState("")
    const [comparePrice, setComparePrice] = useState("")
    const [costPerItem, setCostPerItem] = useState("")
    const [margin, setMargin] = useState("")
    const [profit, setProfit] = useState("")

    const productContext = useContext(ProductContext)
    const router = useRouter()
    const productId = router.query

    useEffect(() => {

        if (update) {

            console.log(update)

        }

    }, [])

    useEffect(() => {

        productContext.dispatch({ 
            type: "updateProduct",
            payload : { 
                pricing : { price, comparePrice, costPerItem }
            }
        })

        if (update) {

            console.log(update)

        }
    }, [price, comparePrice, costPerItem])


    return (
        <Card className="p-3 mt-4 mb-4">

            <h3> Pricing </h3>

            <Row 
                style={{borderBottom: "1px solid grey"}} 
                className="pb-3  pt-3"
            >
                <Col>
                    <Label>
                        Price
                        <Input
                            className="border"
                            type="text"
                            placeholder="$ 0.00"
                            onChange={e => setPrice(e.target.value)}
                            value={price}
                        />
                    </Label>
                </Col>

                <Col>
                    <Label>
                        Compare at price
                        <Input
                            type="text"
                            placeholder="$ 0.00"
                            onChange={e => setComparePrice(e.target.value)}
                            value={comparePrice}
                        />
                    </Label>
                </Col>
            </Row>

            <Row className="pt-3 pb-3"> 

                <Col>
                    <Label>
                        Cost per item
                        <Input
                            type="text"
                            placeholder="$ 0.00"
                            onChange={e => setCostPerItem(e.target.value)}
                            value={costPerItem}
                        />
                    </Label>
                </Col>

                <Col>
                    <Row>
                        <Col>
                            <p> Margin </p>
                            <p> - {margin} - </p>
                        </Col>
                        <Col>
                            <p> Profit </p>
                            <p> - {profit} - </p>
                        </Col>
                    </Row>
                </Col>
            </Row>

            <div className="ml-4">
                <Label>
                    <Input type="checkbox" />
                    Tax on this product
                </Label>
            </div>
        </Card>
    )
}
