import React, { useState, useContext, useEffect } from 'react'
import { Card, Input } from 'reactstrap'
import { ProductContext } from '../../context/products' 
import { useRouter } from 'next/router'

export const ProductStatus = ({ update }) => {

    const [status, setStatus] = useState("")
    const productContext = useContext(ProductContext)

    const router = useRouter()
    const productId = router.query

    useEffect(() => {

        if (update) {

            console.log(update)

        }

    }, [])

    useEffect(() => {

        productContext.dispatch({ type: "updateProduct", payload : { status }})

        if (update) {

            console.log(update)

        }

    }, [status])

  
    return (
        <Card className="p-3 mt-4 mb-4">

            <h3> Product status </h3>

            <div className="pt-3">
                
                <Input type="select" onChange={e => setStatus(e.target.value)}>
                    <option value="">  </option>
                    <option value="draft"> Draft </option>
                    <option value="active"> Active </option>
                </Input>

            </div>
            {/* <div>
                <h4> SALES CHANNELS AND APPS </h4>
                <label>
                    <input type="checkbox"/>
                    online store
                </label>
            </div>        */}

        </Card>
    )
}