import React, { useState, useContext, useEffect } from 'react'
import { Card, Input, Label } from 'reactstrap'
import { ProductContext } from '../../context/products' 
import { useRouter } from 'next/router'


export const Shipping = ({ update }) => {

    const [weight, setWeight] = useState(0)
    const [country, setCountry] = useState("")
    const [hs, setHS] = useState("")

    const productContext = useContext(ProductContext)
    const router = useRouter()
    const productId = router.query

    useEffect(() => {

        if (update) {

            console.log(update)

        }

    }, [])

    useEffect(() => {

        productContext.dispatch({ 
            type: "updateProduct",
            payload : { 
                shipping : { weight, country, hs }
            }
        })

    }, [weight, country, hs])
  
    return (
        <Card className="p-3 mt-4 mb-4">

            <div style={{borderBottom: "1px solid grey"}}>

                <h3> Shipping </h3>

                <Label className="ml-4 pt-3">
                    <Input type="checkbox"/>
                    This is a physical product
                </Label>

            </div>

            <div className="pt-3" style={{borderBottom: "1px solid grey"}}>
                
                <p><b> WEIGHT </b></p>

                <p> Used to calculate shipping rates at checkout and label prices during fulfillment. </p>

                <div className="pb-3">

                    <Label>                    
                        Weight
                        <Input  
                            type="text"
                            value={weight}
                            onChange={e => setWeight(e.target.value)}
                        />
                    </Label>

                    <Input type="select" style={{width:"20%"}}>
                        <option> lb </option>
                        <option> oz </option>
                        <option> kg </option>
                        <option> g </option>
                    </Input>
                </div>
            </div>

            <div className="pt-3">

                <h5> CUSTOMS INFORMATION </h5>

                <p className="pt-2 pb-2"> Customs authorities use this information to calculate duties when shipping internationally. Shown on printed customs forms. </p>
                
                <div className="">
                    <Label>
                        Country/Region of origin
                        <Input  
                            type="text"
                            value={country}
                            onChange={e => setCountry(e.target.value)}
                        />
                    </Label>
                    <p> In most cases, where the product is manufactured. </p>
                </div>
                
                <div>
                    <Label>
                        HS (Harmonized System) code
                        <Input  
                            type="text"
                            value={hs}
                            onChange={e => setHS(e.target.value)}
                        />
                    </Label>
                    <p> Manually enter codes that are longer than 6 numbers. </p>
                </div>
            </div>
        </Card>
    )
}