import React, { useContext, useEffect, useState, } from 'react'
import { Card, Label, Input, } from 'reactstrap'
import { ProductContext } from '../../context/products'
import { useRouter } from 'next/router'


export const TitleAndDescription = ({ update }) => {

    const [title, setTitle] = useState("")
    const [description, setDescription] = useState("")
    const productContext = useContext(ProductContext)
    const router = useRouter()
    const productId = router.query

    useEffect(() => {

        if (update) {

            console.log(productContext.state)

        }
    }, [])

    useEffect(() => {

        if (update) {

            let product = productContext.state.products.filter(product => {
                if (product.productid === productId) { 
                    return product
                }
            })

            console.log(product)
        }
    }, [])

    useEffect(() => {

        console.log("---",update)

        productContext.dispatch({ 
            type: "updateProduct",
            payload : { title, description }
        })

    }, [title, description])

    return (
        <Card className="p-3 mt-4 mb-4">
            <Label>
                Title
                <Input
                    type="text" 
                    value={title}
                    onChange={e => setTitle(e.target.value)}
                    placeholder=""
                />
            </Label>

            <Label> 
                Description
                <Input
                    type="textarea"
                    value={description}
                    onChange={e => setDescription(e.target.value)}
                />
            </Label>
        </Card>
    )
}