import React, { useEffect, useState } from 'react';
import HeaderOne from '../headers/header-one';
import FooterOne from '../footers/footer-one';
import Breadcrubs from '../common/widgets/breadcrubs';
import Helmet from 'react-helmet';
import favicon from '../../public/assets/images/favicon/1.png'

const CommonLayout = ({ children, title, parent ,subTitle }) => {

    const [auth, setAuth] = useState(false)

    useEffect(() => {

        let token = sessionStorage.getItem("token")

        !token || token.length === 0 ? setAuth(false) : setAuth(true)
    
    }, [])

    return (
        <>
        <Helmet>
            <meta name="viewport" content="width=device-width, initial-scale=1" />
            <link rel="icon" type="image/x-icon" href={favicon?favicon:''} />
        </Helmet>
            <HeaderOne topClass="top-header" logoName="logo.png" />
                <Breadcrubs title={title} parent={parent} subTitle={subTitle}  />
                <>{children}</>

            { !auth ? <FooterOne /> : null }
            
        </>
    )
}

export default CommonLayout;