const withImages = require('next-images');
const { withPlugins } = require('next-compose-plugins');
const path = require('path')
const withSass = require('@zeit/next-sass');

module.exports = withSass({ cssModules: true })
  

const nextConfig = {
  env: {
    API_URL: 'http://localhost:8080/graphql', // You can set your graphQL url here
  },
  sassOptions: {
    includePaths: [path.join(__dirname, '/public/asserts/scss')],
  },
  webpack(config, options) {
    config.module.rules.push({
      test: /\.svg$/,
      issuer: {
        test: /\.(js|ts)x?$/,
      },
      use: ['@svgr/webpack'],
    });
    return config
  }
}

module.exports = withPlugins([withImages],nextConfig);