import React, { useEffect, useState } from 'react';
import '../public/assets/scss/app.scss';
import { ToastContainer } from 'react-toastify';
import TapTop from '../components/common/widgets/Tap-Top';
import { MenuContextProvider } from '../helpers/menu/MenuContext';
import CartContextProvider from '../helpers/cart/CartContext';
import { WishlistContextProvider } from '../helpers/wishlist/WishlistContext';
import FilterProvider from '../helpers/filter/FilterProvider';
import SettingProvider from '../helpers/theme-setting/SettingProvider';
import { CompareContextProvider } from '../helpers/Compare/CompareContext';
import { CurrencyContextProvider } from '../helpers/Currency/CurrencyContext';
import '../styles/global.css'
import { ProductProvider } from '../context/products'
import Helmet from 'react-helmet';


export default function MyApp({ Component, pageProps }) {

  useEffect(() => {
    const path = window.location.pathname.split('/');
    const url = path[path.length - 1];

  }, []);
  return (
    <>
      <Helmet>
        <meta name="viewport" content="width=device-width, initial-scale=1" />
        <title>Multikart - Multi-purpopse E-commerce React Template</title>
      </Helmet> 
      <div>
        <SettingProvider>
          <CompareContextProvider>
            <CurrencyContextProvider>
              <CartContextProvider>
                <WishlistContextProvider>
                  <MenuContextProvider>
                    <FilterProvider>
                      <ProductProvider>

                        <Component {...pageProps} />

                      </ProductProvider>
                    </FilterProvider>
                  </MenuContextProvider>
                </WishlistContextProvider>
              </CartContextProvider>
            </CurrencyContextProvider>
            {/* <ThemeSettings /> */}
          </CompareContextProvider>
        </SettingProvider>
        <ToastContainer />
        <TapTop />
      </div>
     
    </>
  )
}