import React, { useState } from 'react';
import CommonLayout from '../components/shop/common-layout';
import { Container, Row, Form, Input,Col } from 'reactstrap';
import router, { useRouter } from 'next/router'
import axios from 'axios'

const ForgetPwd = () => {

    const [email, setEmail] = useState("")

    const sendEmail = async() => {

        try {

            let url = "https://elitecarthub.com/Development/API/swaggerapi/api/forgot-password"

            let res = await axios({ url, method: "POST", data : { email } })

            alert(res.data.message)

            router.push("/")

        } catch (err) {

            alert("err")

            console.log(err)
        }
    }

    return (
        <CommonLayout parent="home" title="Forget Password">
            <section className="pwd-page section-b-space">
                <Container>
                    <Row>
                        <Col lg="6" className="m-auto">
                            <h2>Forget Your Password</h2>
                            <div className="theme-form">
                                <Row>
                                    <Col md="12">
                                        <Input 
                                            value={email}
                                            type="text" 
                                            className="form-control" 
                                            id="email" 
                                            placeholder="Enter Your Email"
                                            required="" 
                                            onChange={e => setEmail(e.target.value)}
                                        />
                                    </Col>
                                    <button 
                                        className="btn btn-solid"
                                        onClick={() => sendEmail()}    
                                    >
                                        Submit
                                    </button>
                                </Row>
                            </div>
                        </Col>
                    </Row>
                </Container>
            </section>
        </CommonLayout>
    )
}

export default ForgetPwd;