import React, { useEffect, useState } from 'react';
import { Input, Modal,ModalBody ,ModalFooter,ModalHeader, Button, Label } from 'reactstrap';
import Link from 'next/link';
import BootstrapTable from 'react-bootstrap-table-next'; 
import filterFactory from 'react-bootstrap-table2-filter'; 
import paginationFactory from 'react-bootstrap-table2-paginator';  
import { useRouter } from 'next/router'
import axios from 'axios'
import { config } from '../../../config/main'

const Countrylist = () =>{
    
    const [columns, setColumns] = useState([{dataField: 'name', text: 'Name',sort: true},
    {dataField: 'code', text: 'Code', sort: true },
    { dataField: 'tax',  text: 'Tax', sort: true },
    {
   dataField: "countryid",
   text: 'Action',
   formatter: (rowContent, row) => {
     //console.log(this);
     return (
          <React.Fragment>
       <a  onClick={e => { e.persist(); editCountry(row.id);}}><i class="fa fa-edit"></i></a>   
       <a  onClick={e => { e.persist(); deleteCountry(row.id);}}><i class="fa fa-trash"></i></a>
       </React.Fragment>
     );
    }
    }]);
    const router = useRouter()
    const [ countries, setCountries] = useState([]);
    const [countrymodal, setCountrymodal] = useState(false); //modal
    const countrytoggle = () => setCountrymodal(!countrymodal); //modal
    
    const [editcountrymodal, setEditcountrymodal] = useState(false); //modal
    const editcountrytoggle = () => setEditcountrymodal(!editcountrymodal); //modal
    const [editcountryname, setEditcountryname] = useState([]);
    const [editcountrycode, setEditcountrycode] = useState([]);
    const [editcountrytax, setEditcountrytax] = useState([]);
    const [editcountryid, setEditcountryid] = useState([]);

    const [deletecountrymodal, setDeletecountrymodal] = useState(false); //modal
    const deletecountrytoggle = () => setDeletecountrymodal(!deletecountrymodal); //modal

    const [name, setCountryname] = useState([]);
    const [code, setCode] = useState([]);
    const [tax, setTax] = useState([]);
    let url = config.API
   
    useEffect(() => {
        fetchcountry(true)
      }, []);
      async function fetchcountry() {
        const token=sessionStorage.getItem("token")
        axios({
            method: 'get',
            url: url+'/get-countries',
            headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
            })
            .then(function (response) {
                //handle success
                let  countries =  response.data.result;
               
                setCountries(countries);
            })
            .catch(function (response) {
                //handle error
             
            });
        }

        const handlecountryClose = () => countrymodal(false);
      const savecountry = async (e) => {
        e.preventDefault()
        if (name.length === 0 || code.length === 0 || tax.length === 0) {
            showErr("all fields are required")            
            return 
        }   
        try {
            const token=sessionStorage.getItem("token")
            const res = await axios({
                method: 'post',
                url: url+'/create-country',
                headers: { 
                    'Content-Type': 'application/json',
                    "Authorization":'Bearer '+token
                },
                data : JSON.stringify({ name, code, tax })
            })
            const { success, err } = res.data

          
            handlecountryClose();
            fetchcountry();
        } catch (err) {

        }
    }

    const handleeditcountryOpen = () => setEditcountrymodal(true);
    const handleeditcountryClose = () => setEditcountrymodal(false);
    const editCountry = (id) => {
        try {
            const token=sessionStorage.getItem("token")
            axios({
                method: 'get',
                url: url+'/edit-country/'+id,
                headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
                })
                .then(function (response) {
                    let  countrydetails = response.data.result;
                            console.log(countrydetails);
                            setEditcountryname(countrydetails.name)
                            setEditcountrycode(countrydetails.code)
                            setEditcountrytax(countrydetails.tax)
                            setEditcountryid(countrydetails.id)
                            handleeditcountryOpen()
                })
                .catch(function (response) {
                    console.log(response);
                });
            } catch (err) {
            }
    }

    const updatecountry = async (e) => {
        e.preventDefault()
        if (editcountryname.length === 0 || editcountrycode.length === 0 || editcountrytax.length === 0) {
            alert("all field is required")            
            return 
        }   
        try {
            const token=sessionStorage.getItem("token")
            let country_id =editcountryid;
            let name = editcountryname;
            let code = editcountrycode;
            let tax = editcountrytax;
            const res = await axios({
                method: 'post',
                url: url+'/update-country',
                headers: { 
                    'Content-Type': 'application/json',
                    "Authorization":'Bearer '+token
                },
                data : JSON.stringify({ country_id,name,code,tax})
            })
            const { err } = res.data
            handleeditcountryClose();
            fetchcountry();
           

        } catch (err) {

        }
    }

    const handledeletecountryOpen = () => setDeletecountrymodal(true);
    const handledeletecountryClose = () => setDeletecountrymodal(false);
    const deleteCountry = (id) => {
        setEditcountryid(id)
        handledeletecountryOpen()
    }
    return (
        <div>
            
            <h3> Countries</h3>
            <button className="btn btn-sm btn-solid m-3"onClick={countrytoggle}>add country </button>
            <BootstrapTable   
                striped 
                hover  
                keyField='id'   
                dataField= "databasePkey"
                data={countries }   
                columns={columns }  
                pagination={ paginationFactory() }
                filter={ filterFactory() }
            />

            <Modal isOpen={countrymodal} toggle={countrytoggle} centered>
            
            <ModalHeader toggle={countrytoggle}>Add new country</ModalHeader>
            
            <ModalBody className="p-4">
            
                <div className="form-group">
                    <Label for="Role">Country Name</Label>
                    <Input 
                        type="text" 
                        className="form-control" 
                        id="Role" 
                        placeholder="Enter Country name" 
                        required=""
                        onChange={(e) => setCountryname(e.target.value)}
                    />
                </div>
                <div className="form-group">
                    <Label for="Role">Country Code</Label>
                    <Input 
                        type="text" 
                        className="form-control" 
                        id="Code" 
                        placeholder="Enter Code" 
                        required=""
                        onChange={(e) => setCode(e.target.value)}
                    />
                </div>
                <div className="form-group">
                    <Label for="Role">Tax</Label>
                    <Input 
                        type="text" 
                        className="form-control" 
                        id="Tax" 
                        placeholder="Enter Tax" 
                        required=""
                        onChange={(e) => setTax(e.target.value)}
                    />
                </div>

            </ModalBody>

            <ModalFooter>
                <Link href={'/'}><a className="btn-solid btn-custom"onClick={savecountry} color="secondary">Save</a></Link>
                <Button className="btn-solid btn-custom" color="secondary" onClick={countrytoggle}>Cancel</Button>
            </ModalFooter>
        </Modal>

        <Modal isOpen={editcountrymodal} toggle={editcountrytoggle} centered>

            <ModalHeader toggle={editcountrytoggle}>Edit country</ModalHeader>
            
            <ModalBody className="p-4">
            
                <div className="form-group">
                    <Label for="countryname">Country Name</Label>
                    
                    <Input 
                        type="text" 
                        className="form-control" 
                        id="countryname" 
                        placeholder="Enter Country name" 
                        value={editcountryname}
                        required=""
                        onChange={(e) => setEditcountryname(e.target.value)}
                    />
                </div>
                <div className="form-group">
                    <Label for="Role">Country Code</Label>
                    <Input 
                        type="text" 
                        className="form-control" 
                        id="Code" 
                        placeholder="Enter Code" 
                        value={editcountrycode}
                        required=""
                        onChange={(e) => setEditcountrycode(e.target.value)}
                    />
                </div>
                <div className="form-group">
                    <Label for="Role">Tax</Label>
                    <Input 
                        type="text" 
                        className="form-control" 
                        id="Tax" 
                        value={editcountrytax}
                        placeholder="Enter Tax" 
                        required=""
                        onChange={(e) => setEditcountrytax(e.target.value)}
                    />
                </div>
        
            </ModalBody>

            <ModalFooter>
                <Link href={'/'}><a className="btn-solid btn-custom"onClick={updatecountry} color="secondary">Update</a></Link>
                <Button className="btn-solid btn-custom" color="secondary" onClick={editcountrytoggle}>Cancel</Button>
            </ModalFooter>
        </Modal>

        <Modal isOpen={deletecountrymodal} toggle={deletecountrytoggle} centered>
            
            <ModalHeader toggle={deletecountrytoggle}>Delete country</ModalHeader>
            
            <ModalBody className="p-4">
            
            <div className="form-group">
                <Input 
                    type="hidden" 
                    className="form-control" 
                    id="editcountryid" 
                    value={editcountryid}
                    required=""
                />
            </div>        
            </ModalBody>
            <ModalFooter>
                <Link href={'/'}><a className="btn-solid btn-custom"onClick={updatecountry} color="secondary">Are you sure!</a></Link>
                <Button className="btn-solid btn-custom" color="secondary" onClick={deletecountrytoggle}>Cancel</Button>
            </ModalFooter>
        </Modal>
        </div>
    )
} 

export default Countrylist;