import React, { useEffect, useState } from 'react';
import { Row, Col, Input, Modal,ModalBody ,ModalFooter,ModalHeader, Button, Label } from 'reactstrap';
import { useRouter } from 'next/router'
import BootstrapTable from 'react-bootstrap-table-next'; //paginator
import filterFactory from 'react-bootstrap-table2-filter'; //paginator
import paginationFactory from 'react-bootstrap-table2-paginator';  //paginator
import Link from 'next/link';
import axios from 'axios'
import { config } from '../../../../config/main'
import "react-datepicker/dist/react-datepicker.css";

const Provincelist = (props) =>{

    const [columns, setColumns] = useState([{dataField: 'countryname', text: 'Country',sort: true},
    {dataField: 'code', text: 'Code', sort: true },
    {dataField: 'name', text: 'Name', sort: true },
    {dataField: 'tax', text: 'Tax', sort: true },
    {dataField: 'taxname', text: 'Taxname', sort: true },
    {dataField: 'taxpercentage', text: 'Taxpercentage', sort: true },
    {dataField: 'taxtype', text: 'Taxtype', sort: true },
    {
   dataField: "provinceid",
   text: 'Action',
   formatter: (rowContent, row) => {
     //console.log(this);
     return (
          <React.Fragment>
       <a  onClick={e => { e.persist(); editprovince(row.id);}}><i class="fa fa-edit"></i></a>   
       <a  onClick={e => { e.persist(); deleteprovince(row.id);}}><i class="fa fa-trash"></i></a>
       </React.Fragment>
     );
    }
    }]);

    const router = useRouter() 
    const [startDate, setStartDate] = useState(new Date());
    const [endDate, setEndDate] = useState(new Date());
    const [ provinces, setProvinces] = useState([]);
    const [ countries, setCountries] = useState([]);
    const [provincemodal, setProvincemodal] = useState(false); //modal
    const provincetoggle = () => setProvincemodal(!provincemodal); //modal title
    const [ provincecountry, setProvincecountry] = useState([]);
    const [ provincecode, setProvincecode] = useState([]);
    const [ provincename, setProvincename] = useState([]);
    const [ provincetax, setProvincetax] = useState([]);
    const [ provincetaxname, setProvincetaxname] = useState([]);
    const [ provincetaxpercentage, setProvincetaxpercetage] = useState([]);
    const [ provincetaxtype, setProvincetaxtype] = useState([]);
    const [editprovincemodal, setEditprovincemodal] = useState(false); //modal
    const editprovincetoggle = () => setEditprovincemodal(!editprovincemodal); //modal
    const [ editprovinceid, setEditProvinceid] = useState([]);
    const [ editprovincecountry, setEditProvincecountry] = useState([]);
    const [ editprovincecode, setEditProvincecode] = useState([]);
    const [ editprovincename, setEditProvincename] = useState([]);
    const [ editprovincetax, setEditProvincetax] = useState([]);
    const [ editprovincetaxname, setEditProvincetaxname] = useState([]);
    const [ editprovincetaxpercentage, setEditProvincetaxpercentage] = useState([]);
    const [ editprovincetaxtype, setEditProvincetaxtype] = useState([]);
    
    const [deletepricerulemodal, setDeletepricerulemodal] = useState(false); //modal
    const deletepriceruletoggle = () => setDeletepricerulemodal(!deletepricerulemodal); //modal

    let url = config.API

    useEffect(() => {
        fetchprovinceData()
      }, []);
      async function fetchprovinceData() {
        const token =sessionStorage.getItem("token")
        axios({
            method: 'get',
            url: url+'/get-province',
            // data: bodyFormData,
            headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
            })
            .then(function (response) {
                //handle success
                let  provinces =  response.data.result;
              
                setProvinces(provinces);
            })
            .catch(function (response) {
                //handle error
              
            });
      }
      async function fetchcountry() {
        const token =sessionStorage.getItem("token")
        axios({
            method: 'get',
            url: url+'/get-countries',
            // data: bodyFormData,
            headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
            })
            .then(function (response) {
                //handle success
                let  countries =  response.data.result;
             
                setCountries(countries);
            })
            .catch(function (response) {
                //handle error
            
            });
        }
      const handleprovinceClose = () => setProvincemodal(false);
      const onChange = event => {
        const pickedDate = event.path.to.value;
        setStartDate(pickedDate);
        setPricerulestartat(pickedDate);
      }  
      const saveprovince = async (e) => {
        e.preventDefault()
        if (provincecountry.length === 0 || provincecode.length === 0 || provincename.length === 0 || 
            provincetax.length === 0 || provincetaxname.length === 0 || provincetaxpercentage.length === 0 || 
            provincetaxtype.length === 0 ) {
            alert("all field is required")            
            return 
        }   
        try {
            const token =sessionStorage.getItem("token")
            let countryid = provincecountry;
            let code =provincecode ;
            let name =provincename ;
            let tax =provincetax ;
            let taxname =provincetaxname ;
            let taxpercentage =provincetaxpercentage ;
            let taxtype =provincetaxtype ;
            const res = await axios({
                method: 'post',
                url: url+'/create-province',
                headers: { 
                    'Content-Type': 'application/json',
                    "Authorization":'Bearer '+token
                },
                data : JSON.stringify({ countryid,code ,name ,tax ,taxname ,taxpercentage ,taxtype })
            })
            const { err } = res.data
            handleprovinceClose();
            fetchprovinceData();
            console.log(err)

        } catch (err) {

        }
    }
    const handleeditprovinceOpen = () => setEditprovincemodal(true);
    const handleeditprovinceClose = () => setEditprovincemodal(false);
    const editprovince = (id) => {
        try {
            const token =sessionStorage.getItem("token")
            axios({
                method: 'get',
                url: url+'/edit-province/'+id,
                headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
                })
                .then(function (response) {
                    let  provincedetails = response.data.result;
                            console.log(provincedetails);
                            setEditProvinceid(provincedetails.id)
                            setEditProvincecountry(provincedetails.countryid)
                            setEditProvincecode(provincedetails.code)
                            setEditProvincename(provincedetails.name)
                            setEditProvincetax(provincedetails.tax)
                            setEditProvincetaxname(provincedetails.taxname)
                            setEditProvincetaxpercentage(provincedetails.taxpercentage)
                            setEditProvincetaxtype(provincedetails.taxtype)
                            handleeditprovinceOpen()
                })
                .catch(function (response) {
                    console.log(response);
                });
            } catch (err) {
            }
    }
    const updatepricerule = async (e) => {
        e.preventDefault()
        if (editprovincecountry.length === 0 || editprovincecode.length === 0 || editprovincename.length === 0 || 
            editprovincetax.length === 0 || editprovincetaxname.length === 0 || editprovincetaxpercentage.length === 0 || 
            editprovincetaxtype.length === 0 ) {
            alert("all field is required")            
            return 
        }    
        try {
            const token =sessionStorage.getItem("token")
            let provinceid =editprovinceid;
            let countryid = editprovincecountry;
            let code =editprovincecode ;
            let name =editprovincename ;
            let tax =editprovincetaxname ;
            let taxname =editprovincetaxpercentage ;
            let taxpercentage =editprovincetaxpercentage ;
            let taxtype =editprovincetaxtype ;
            const res = await axios({
                method: 'post',
                url: url+'/update-pricerule',
                headers: { 
                    'Content-Type': 'application/json',
                    "Authorization":'Bearer '+token
                },
                data : JSON.stringify({ provinceid, countryid ,code ,name ,tax ,taxname ,taxpercentage ,taxtype  })
            })
            const { err } = res.data
            handleeditpriceruleClose();
            fetchpriceruleData();
            console.log(err)

        } catch (err) {

        }
    }
    function handleChange(event) {
        setProvincecountry({ [event.target.name]: event.target.value });
      }
    const countrylists=  countries.map((country, index) => (
        <option eventKey={index}>country.name</option>
      ));
    const handledeletepriceruleOpen = () => setDeletepricerulemodal(true);
    const handledeletepriceruleClose = () => setDeletepricerulemodal(false);
    const deleteprovince = (id) => {
        setEditPriceruleid(id)
        handledeletepriceruleOpen()
    }
    let optioncountryItems = countries.map((values) =>
    <option value={values.id}key={values.name}>{values.name}</option>
      );
    return (
        <div>
            
        <h3> provinces</h3>
        <button className="btn btn-sm btn-solid m-3"onClick={provincetoggle}>add province </button>
        <BootstrapTable   
        striped 
        hover  
        keyField='id'   
        dataField= "databasePkey"
        data={provinces }   
        columns={columns }  
        pagination={ paginationFactory() }
        filter={ filterFactory() }/>
                                                <Modal isOpen={provincemodal} toggle={provincetoggle} centered>
                                <ModalHeader toggle={provincetoggle}>Add pricerule</ModalHeader>
                                <ModalBody className="p-4">
                                <Row>
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="title">country</Label> 
                                        <select  value={provincecountry} className="form-control"  onChange={handleChange}>
                                        {optioncountryItems}
                                        </select>
                                        
                                    </div>
                                    </Col>
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="usagelimit">Code</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="code" 
                                            placeholder="Code" 
                                            required=""
                                            onChange={(e) => setProvincecode(e.target.value)}
                                        />
                                    </div>                   
                                    </Col>
                                    <Col sm="4">                     
                                    <div className="form-group">
                                        <Label for="value">name</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="name" 
                                            placeholder="Name" 
                                            required=""
                                            onChange={(e) => setProvincename(e.target.value)}
                                        />
                                    </div> 
                                    </Col>
                                    </Row>
                                    <Row>
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="valuetype">tax</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="tax" 
                                            placeholder="Tax" 
                                            required=""
                                            onChange={(e) => setProvincetax(e.target.value)}
                                        />
                                    </div>
                                    </Col> 
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="startat">Taxname</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="taxname" 
                                            placeholder="Taxname" 
                                            required=""
                                            onChange={(e) => setProvincetaxname(e.target.value)}
                                        />
                                    </div>     
                                    </Col> 
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="endat">Tax percentage</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="taxpercentage" 
                                            placeholder="Tax percentage" 
                                            required=""
                                            onChange={(e) => setProvincetaxpercetage(e.target.value)}
                                        />
                                    </div> 
                                    </Col>  
                                    </Row> 
                                    <Row>
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="quantitypricerange">Tax type</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="taxtype" 
                                            placeholder="Tax type" 
                                            required=""
                                            onChange={(e) => setProvincetaxtype(e.target.value)}
                                        />
                                    </div>
                                    </Col> 
                                   
                                    </Row>                    
                                </ModalBody>
                                <ModalFooter>
                                    <Link href={'/'}><a className="btn-solid btn-custom"onClick={saveprovince} color="secondary">Save</a></Link>
                                    <Button className="btn-solid btn-custom" color="secondary" onClick={provincetoggle}>Cancel</Button>
                                </ModalFooter>
                         </Modal>
                         <Modal isOpen={editprovincemodal} toggle={editprovincetoggle} centered>
                                <ModalHeader toggle={editprovincetoggle}>Update pricerule</ModalHeader>
                                <ModalBody className="p-4">
                                <Row>
                                    <Col sm="4"> 
                                    <Input 
                                            type="hidden" 
                                            id="provinceid" 
                                            value={editprovinceid}
                                            required=""
                                            onChange={(e) => setEditProvinceid(e.target.value)}
                                        />
                                    <div className="form-group">
                                        <Label for="country">Country</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="country" 
                                            value={editprovincecountry}
                                            placeholder="country" 
                                            required=""
                                            onChange={(e) => setEditProvincecountry(e.target.value)}
                                        />
                                    </div>
                                    </Col>
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="name">Name</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="name" 
                                            value={editprovincename}
                                            placeholder="name" 
                                            required=""
                                            onChange={(e) => setEditProvincename(e.target.value)}
                                        />
                                    </div>                   
                                    </Col>
                                    <Col sm="4">                     
                                    <div className="form-group">
                                        <Label for="code">Code</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="code" 
                                            value={editprovincecode}
                                            placeholder="Code" 
                                            required=""
                                            onChange={(e) => setEditProvincecode(e.target.value)}
                                        />
                                    </div> 
                                    </Col>
                                    </Row>
                                    <Row>
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="valuetype">Tax</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="tax" 
                                            value={editprovincetax}
                                            placeholder="tax" 
                                            required=""
                                            onChange={(e) => setEditProvincetax(e.target.value)}
                                        />
                                    </div>
                                    </Col> 
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="taxname">Tax name</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="taxname" 
                                            value={editprovincetaxname}
                                            placeholder="taxname" 
                                            required=""
                                            onChange={(e) => setEditProvincetaxname(e.target.value)}
                                        />
                                    </div>     
                                    </Col> 
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="taxpercentage">Tax percentage</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="taxpercentage" 
                                            value={editprovincetaxpercentage}
                                            placeholder="Tax percentage" 
                                            required=""
                                            onChange={(e) => setEditProvincetaxpercentage(e.target.value)}
                                        />
                                    </div> 
                                    </Col>  
                                    </Row> 
                                    <Row>
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="taxtype">Tax type</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="taxtype" 
                                            value={editprovincetaxtype}
                                            placeholder="taxtype" 
                                            required=""
                                            onChange={(e) => setEditProvincetaxtype(e.target.value)}
                                        />
                                    </div>
                                    </Col> 
                                   
                                    </Row>                    
                                </ModalBody>
                                <ModalFooter>
                                    <Link href={'/'}><a className="btn-solid btn-custom"onClick={updatepricerule} color="secondary">Save</a></Link>
                                    <Button className="btn-solid btn-custom" color="secondary" onClick={editprovincetoggle}>Cancel</Button>
                                </ModalFooter>
                         </Modal>
                         <Modal isOpen={deletepricerulemodal} toggle={deletepriceruletoggle} centered>
                            <ModalHeader toggle={deletepriceruletoggle}>Delete Pricerule</ModalHeader>
                            <ModalBody className="p-4">
                            <div className="form-group">
                                        <Input 
                                            type="hidden" 
                                            className="form-control" 
                                            id="editprovinceid" 
                                            value={editprovinceid}
                                            required=""
                                        />
                                    </div>

                        
                            </ModalBody>
                            <ModalFooter>
                                <Link href={'/'}><a className="btn-solid btn-custom"onClick={updatepricerule} color="secondary">Are you sure!</a></Link>
                                <Button className="btn-solid btn-custom" color="secondary" onClick={deletepriceruletoggle}>Cancel</Button>
                            </ModalFooter>
                        </Modal>
        </div>
    )
} 
export default Provincelist;