import React, { useEffect, useState } from 'react';
import { Input, Modal,ModalBody ,ModalFooter,ModalHeader, Button, Label } from 'reactstrap';
import { useRouter } from 'next/router'
import BootstrapTable from 'react-bootstrap-table-next'; //paginator
import filterFactory from 'react-bootstrap-table2-filter'; //paginator
import paginationFactory from 'react-bootstrap-table2-paginator';  //paginator
import axios from 'axios'
import Link from 'next/link';
import { config } from '../../../config/main'

const Permissionlist = (props) =>{

    const [columns, setColumns] = useState([{dataField: 'label', text: 'Name',sort: true},
    {
   dataField: "permissionid",
   text: 'Action',
   formatter: (rowContent, row) => {
     //console.log(this);
     return (
          <React.Fragment>
       <a  onClick={e => { e.persist(); editPermission(row.value);}}><i class="fa fa-edit"></i></a>   
       <a  onClick={e => { e.persist(); deletePermission(row.value);}}><i class="fa fa-trash"></i></a>
       </React.Fragment>
     );
    }
    }]);
    const router = useRouter()
    const [permissions, setPermissions] = useState([]);
    const [permissionmodal, setPermissionmodal] = useState(false); //modal
    const permissiontoggle = () => setPermissionmodal(!permissionmodal); //modal

    const [editpermissionmodal, setEditpermissionmodal] = useState(false); //modal
    const editpermissiontoggle = () => setEditpermissionmodal(!editpermissionmodal); //modal
    const [editpermissionname, setEditpermissionname] = useState([]);
    const [editpermissionid, setEditpermissionid] = useState([]);

    const [deletepermissionmodal, setDeletepermissionmodal] = useState(false); //modal
    const deletepermissiontoggle = () => setDeletepermissionmodal(!deletepermissionmodal); //modal

    const [name, setPermissionname] = useState([]);

    let url = config.API
    let token =config.Token
    useEffect(() => {
        fetchData();
    }, []);
    async function fetchData() {
        try {
            const token=sessionStorage.getItem("token")
           
        axios({
            method: 'get',
            url: url+'/get-permissions',
            // data: bodyFormData,
            headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
            })
            .then(function (response) {
                //handle success
                let  permissions =  response.data.result;
              
                setPermissions(permissions);
            })
            .catch(function (response) {
                //handle error
              
            });
        } catch (err) {
        }
          }
         
          const handlepermissionClose = () => setPermissionmodal(false);
         
      const savepermission = async (e) => {
        e.preventDefault()
        if (name.length === 0) {
            alert("name field is required")            
            return 
        }   
        try {
            const token=sessionStorage.getItem("token")
            axios({
                method: 'post',
                url: url+'/create-permission',
                data : JSON.stringify({ name }),
                headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
                })
                .then(function (response) {
                   
                    getpermissions();
                    fetchData();
                    handlepermissionClose();
                })
                .catch(function (response) {
                    //handle error
                    // console.log(response);
                });     
        } catch (err) {

        }
    }
    const handleeditpermissionOpen = () => setEditpermissionmodal(true);
    const handleeditpermissionClose = () => setEditpermissionmodal(false);
    const editPermission = (id) => {
      
        const token=sessionStorage.getItem("token")
       
            handleeditpermissionOpen();
            axios({
                method: 'get',
                url: url+'/edit-permission/'+id,
                headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
                })
                .then(function (response) {
                           console.log(response);
                            let  permissionname = response.data.result;
               
                setEditpermissionname(permissionname.name)
                setEditpermissionid(permissionname.id)
                })
                .catch(function (response) {
                    //handle error
                    console.log(response);
                });
    }
    const updatepermission = async (e) => {
        e.preventDefault()
        if (editpermissionname.length === 0) {
            alert("name field is required")            
            return 
        }   
        try {
            const token=sessionStorage.getItem("token")
            let permissionid =editpermissionid;
            let name = editpermissionname;
            const res = await axios({
                method: 'post',
                url: url+'/update-permission',
                headers: { 
                    'Content-Type': 'application/json',
                    "Authorization":'Bearer '+token
                },
                data : JSON.stringify({ permissionid,name })
            })
            const { err } = res.data
            handleeditpermissionClose();
            fetchData();
           
        } catch (err) {

        }
    }
    
    const handledeletepermissionOpen = () => setDeletepermissionmodal(true);
    const handledeletepermissionClose = () => setDeletepermissionmodal(false);
    const deletePermission = (id) => {
      
        handledeletepermissionOpen()
    }
    return (
        <div>
        <h3> Permissions</h3>
        <button className="btn btn-sm btn-solid m-3"onClick={permissiontoggle}>add permission </button>
                    <BootstrapTable   
                    striped 
                    hover  
                    keyField='id'   
                    dataField= "databasePkey"
                    data={permissions }   
                    columns={columns }  
                    pagination={ paginationFactory() }
                    filter={ filterFactory() }/>
                            <Modal isOpen={permissionmodal} toggle={permissiontoggle} centered>
                                <ModalHeader toggle={permissiontoggle}>Add new permission</ModalHeader>
                                <ModalBody className="p-4">
                                    <div className="form-group">
                                        <Label for="Role">Permission Name</Label>
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="Role" 
                                            placeholder="Permission" 
                                            required=""
                                            onChange={(e) => setPermissionname(e.target.value)}
                                        />
                                    </div>

                        
                                </ModalBody>
                                <ModalFooter>
                                    <Link href={'/'}><a className="btn-solid btn-custom"onClick={savepermission} color="secondary">Save</a></Link>
                                    <Button className="btn-solid btn-custom" color="secondary" onClick={permissiontoggle}>Cancel</Button>
                                </ModalFooter>
                         </Modal>

                        <Modal isOpen={editpermissionmodal} toggle={editpermissiontoggle} centered>
                            <ModalHeader toggle={editpermissiontoggle}>Edit permission</ModalHeader>
                            <ModalBody className="p-4">
                            <div className="form-group">
                                        <Label for="Role">Permission Name</Label>
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="editpermissionname" 
                                            value={editpermissionname}
                                            placeholder="Permission" 
                                            required=""
                                            onChange={(e) => setEditpermissionname(e.target.value)}
                                        />
                                        <Input 
                                            type="hidden" 
                                            className="form-control" 
                                            id="editpermissionid" 
                                            value={editpermissionid}
                                            placeholder="Permission" 
                                            required=""
                                            onChange={(e) => setEditpermissionid(e.target.value)}
                                        />
                                    </div>

                        
                            </ModalBody>
                            <ModalFooter>
                                <Link href={'/'}><a className="btn-solid btn-custom"onClick={updatepermission} color="secondary">Update</a></Link>
                                <Button className="btn-solid btn-custom" color="secondary" onClick={editpermissiontoggle}>Cancel</Button>
                            </ModalFooter>
                        </Modal>

                        <Modal isOpen={deletepermissionmodal} toggle={deletepermissiontoggle} centered>
                            <ModalHeader toggle={deletepermissiontoggle}>Delete permission</ModalHeader>
                            <ModalBody className="p-4">
                           

                        
                            </ModalBody>
                            <ModalFooter>
                                <Link href={'/'}><a className="btn-solid btn-custom"onClick={updatepermission} color="secondary">Are you sure!</a></Link>
                                <Button className="btn-solid btn-custom" color="secondary" onClick={deletepermissiontoggle}>Cancel</Button>
                            </ModalFooter>
                        </Modal>
        </div>
    )
} 
export default Permissionlist;