import React, { useEffect, useState } from 'react';
import { Row, Col, Input, Modal,ModalBody ,ModalFooter,ModalHeader, Button, Label } from 'reactstrap';
import { useRouter } from 'next/router'
import BootstrapTable from 'react-bootstrap-table-next'; //paginator
import filterFactory from 'react-bootstrap-table2-filter'; //paginator
import paginationFactory from 'react-bootstrap-table2-paginator';  //paginator
import DatePicker from "react-datepicker"
import Link from 'next/link';
import axios from 'axios'
import { config } from '../../../config/main'
import "react-datepicker/dist/react-datepicker.css";

const Pricerulelist = (props) =>{

    const [columns, setColumns] = useState([{dataField: 'title', text: 'Title',sort: true},
    {dataField: 'usagelimit', text: 'Usagelimit', sort: true },
    {dataField: 'value', text: 'Value', sort: true },
    {dataField: 'valuetype', text: 'Valuetype', sort: true },
    {dataField: 'startat', text: 'Start at', sort: true },
    {dataField: 'endat', text: 'End at', sort: true },
    {dataField: 'quantitypricerange', text: 'Quantity Pricerange', sort: true },
    {dataField: 'shippingpricerange', text: 'Shipping Pricerange', sort: true },
    {dataField: 'subtotalrange', text: 'Subtotal range', sort: true },
    {
   dataField: "priceruleid",
   text: 'Action',
   formatter: (rowContent, row) => {
     //console.log(this);
     return (
          <React.Fragment>
       <a  onClick={e => { e.persist(); editpricerule(row.id);}}><i class="fa fa-edit"></i></a>   
       <a  onClick={e => { e.persist(); deletepricerule(row.id);}}><i class="fa fa-trash"></i></a>
       </React.Fragment>
     );
    }
    }]);

    const router = useRouter() 
    const [startDate, setStartDate] = useState(new Date());
    const [endDate, setEndDate] = useState(new Date());
    const [ pricerules, setPricerules] = useState([]);
    const [pricerulemodal, setPricerulemodal] = useState(false); //modal
    const priceruletoggle = () => setPricerulemodal(!pricerulemodal); //modal title
    const [ priceruletitle, setPriceruletitle] = useState([]);
    const [ priceruleusagelimit, setPriceruleusagelimit] = useState([]);
    const [ pricerulevalue, setPricerulevalue] = useState([]);
    const [ pricerulevaluetype, setPricerulevaluetype] = useState([]);
    const [ pricerulestartat, setPricerulestartat] = useState([]);
    const [ priceruleendat, setPriceruleendat] = useState([]);
    const [ pricerulequantitypricerange, setPricerulequantitypricerange] = useState([]);
    const [ priceruleshippingpricerange, setPriceruleshippingpricerange] = useState([]);
    const [ pricerulesubtotalrange, setPricerulesubtotalrange] = useState([]);
    const [ editpriceruleid, setEditPriceruleid] = useState([]);
    const [editpricerulemodal, setEditpricerulemodal] = useState(false); //modal
    const editpriceruletoggle = () => setEditpricerulemodal(!editpricerulemodal); //modal
    const [ editpriceruletitle, setEditPriceruletitle] = useState([]);
    const [ editpriceruleusagelimit, setEditPriceruleusagelimit] = useState([]);
    const [ editpricerulevalue, setEditPricerulevalue] = useState([]);
    const [ editpricerulevaluetype, setEditPricerulevaluetype] = useState([]);
    const [ editpricerulestartat, setEditPricerulestartat] = useState([]);
    const [ editpriceruleendat, setEditPriceruleendat] = useState([]);
    const [ editpricerulequantitypricerange, setEditPricerulequantitypricerange] = useState([]);
    const [ editpriceruleshippingpricerange, setEditPriceruleshippingpricerange] = useState([]);
    const [ editpricerulesubtotalrange, setEditPricerulesubtotalrange] = useState([]);
    
    const [deletepricerulemodal, setDeletepricerulemodal] = useState(false); //modal
    const deletepriceruletoggle = () => setDeletepricerulemodal(!deletepricerulemodal); //modal

    let url = config.API
    
    useEffect(() => {
        fetchpriceruleData()
      }, []);
      async function fetchpriceruleData() {
        const token=sessionStorage.getItem("token")
        axios({
            method: 'get',
            url: url+'/get-pricerule',
            // data: bodyFormData,
            headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
            })
            .then(function (response) {
                //handle success
                let  pricerules =  response.data.result;
             
                setPricerules(pricerules);
            })
            .catch(function (response) {
                //handle error
              
            });
       
      }
      const handlepriceruleClose = () => setPricerulemodal(false);
      const onChange = event => {
        const pickedDate = event.path.to.value;
        setStartDate(pickedDate);
        setPricerulestartat(pickedDate);
      }  
      const savepricerule = async (e) => {
        e.preventDefault()
        if (priceruletitle.length === 0 || priceruleusagelimit.length === 0 || pricerulevalue.length === 0 || 
            pricerulevaluetype.length === 0 || pricerulestartat.length === 0 || priceruleendat.length === 0 || 
            pricerulequantitypricerange.length === 0 || priceruleshippingpricerange.length === 0 || pricerulesubtotalrange.length === 0 ) {
            alert("all field is required")            
            return 
        }   
        try {
            const token=sessionStorage.getItem("token")
            let title = priceruletitle;
            let usagelimit =priceruleusagelimit ;
            let value =pricerulevalue ;
            let valuetype =pricerulevaluetype ;
            let startat =startDate ;
            let endat =endDate ;
            let quantitypricerange =pricerulequantitypricerange ;
            let shippingpricerange =priceruleshippingpricerange ;
            let subtotalrange =pricerulesubtotalrange ;
            const res = await axios({
                method: 'post',
                url: url+'/create-pricerule',
                headers: { 
                    'Content-Type': 'application/json',
                    "Authorization":'Bearer '+token
                },
                data : JSON.stringify({ title,usagelimit ,value ,valuetype ,startat ,endat ,quantitypricerange ,shippingpricerange ,subtotalrange })
            })
            const { err } = res.data
            handlepriceruleClose();
            fetchpriceruleData();
          

        } catch (err) {

        }
    }
    const handleeditpriceruleOpen = () => setEditpricerulemodal(true);
    const handleeditpriceruleClose = () => setEditpricerulemodal(false);
    const editpricerule = (id) => {
        try {
            const token=sessionStorage.getItem("token")
            axios({
                method: 'get',
                url: url+'/edit-pricerule/'+id,
                headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
                })
                .then(function (response) {
                    let  priceruledetails = response.data.result;
                            console.log(priceruledetails);
                            setEditPriceruleid(priceruledetails.id)
                            setEditPriceruletitle(priceruledetails.title)
                            setEditPriceruleusagelimit(priceruledetails.usagelimit)
                            setEditPricerulevalue(priceruledetails.value)
                            setEditPricerulevaluetype(priceruledetails.valuetype)
                            setEditPricerulestartat(priceruledetails.startat)
                            setEditPriceruleendat(priceruledetails.endat)
                            setEditPricerulequantitypricerange(priceruledetails.quantitypricerange)
                            setEditPriceruleshippingpricerange(priceruledetails.shippingpricerange)
                            setEditPricerulesubtotalrange(priceruledetails.subtotalrange)
                            handleeditpriceruleOpen()
                })
                .catch(function (response) {
                    console.log(response);
                });
            } catch (err) {
            }
    }
    const updatepricerule = async (e) => {
        e.preventDefault()
        if (editpriceruletitle.length === 0 || editpriceruleusagelimit.length === 0 || editpricerulevalue.length === 0 || 
            editpricerulevaluetype.length === 0 || editpricerulestartat.length === 0 || editpriceruleendat.length === 0 || 
            editpricerulequantitypricerange.length === 0 || editpriceruleshippingpricerange.length === 0 || editpricerulesubtotalrange.length === 0 ) {
            alert("all field is required")            
            return 
        }    
        try {
            const token=sessionStorage.getItem("token")
            let priceruleid =editpriceruleid;
            let title = editpriceruletitle;
            let usagelimit =editpriceruleusagelimit ;
            let value =editpricerulevalue ;
            let valuetype =editpricerulevaluetype ;
            let startat =editpricerulestartat ;
            let endat =editpriceruleendat ;
            let quantitypricerange =editpricerulequantitypricerange ;
            let shippingpricerange =editpriceruleshippingpricerange ;
            let subtotalrange =editpricerulesubtotalrange ;
            const res = await axios({
                method: 'post',
                url: url+'/update-pricerule',
                headers: { 
                    'Content-Type': 'application/json',
                    "Authorization":'Bearer '+token
                },
                data : JSON.stringify({ priceruleid, title ,usagelimit ,value ,valuetype ,startat ,endat ,quantitypricerange ,shippingpricerange ,subtotalrange })
            })
            const { err } = res.data
            handleeditpriceruleClose();
            fetchpriceruleData();
           

        } catch (err) {

        }
    }

    const handledeletepriceruleOpen = () => setDeletepricerulemodal(true);
    const handledeletepriceruleClose = () => setDeletepricerulemodal(false);
    const deletepricerule = (id) => {
        setEditPriceruleid(id)
        handledeletepriceruleOpen()
    }
    return (
        <div>
            
        <h3> Pricerules</h3>
        <button className="btn btn-sm btn-solid m-3"onClick={priceruletoggle}>add pricerule </button>
        <BootstrapTable   
        striped 
        hover  
        keyField='id'   
        dataField= "databasePkey"
        data={pricerules }   
        columns={columns }  
        pagination={ paginationFactory() }
        filter={ filterFactory() }/>
                                                <Modal isOpen={pricerulemodal} toggle={priceruletoggle} centered>
                                <ModalHeader toggle={priceruletoggle}>Add pricerule</ModalHeader>
                                <ModalBody className="p-4">
                                <Row>
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="title">Title</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="title" 
                                            placeholder="Title" 
                                            required=""
                                            onChange={(e) => setPriceruletitle(e.target.value)}
                                        />
                                    </div>
                                    </Col>
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="usagelimit">Usagelimit</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="usagelimit" 
                                            placeholder="Usagelimit" 
                                            required=""
                                            onChange={(e) => setPriceruleusagelimit(e.target.value)}
                                        />
                                    </div>                   
                                    </Col>
                                    <Col sm="4">                     
                                    <div className="form-group">
                                        <Label for="value">Value</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="value" 
                                            placeholder="Value" 
                                            required=""
                                            onChange={(e) => setPricerulevalue(e.target.value)}
                                        />
                                    </div> 
                                    </Col>
                                    </Row>
                                    <Row>
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="valuetype">Valuetype</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="valuetype" 
                                            placeholder="Valuetype" 
                                            required=""
                                            onChange={(e) => setPricerulevaluetype(e.target.value)}
                                        />
                                    </div>
                                    </Col> 
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="startat">Start at</Label> 
                                        <DatePicker className="form-control"selected={startDate}dateFormat="yyyy-MM-dd" onChange={date => setStartDate(date)} />
                                    </div>     
                                    </Col> 
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="endat">End at</Label> 
                                        <DatePicker className="form-control"selected={endDate}dateFormat="yyyy-MM-dd" onChange={(date) => setEndDate(date)} />
                                    </div> 
                                    </Col>  
                                    </Row> 
                                    <Row>
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="quantitypricerange">Quantitypricerange</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="quantitypricerange" 
                                            placeholder="Quantitypricerange" 
                                            required=""
                                            onChange={(e) => setPricerulequantitypricerange(e.target.value)}
                                        />
                                    </div>
                                    </Col> 
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="shippingpricerange">shippingpricerange</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="shippingpricerange" 
                                            placeholder="shippingpricerange" 
                                            required=""
                                            onChange={(e) => setPriceruleshippingpricerange(e.target.value)}
                                        />
                                    </div>
                                    </Col> 
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="subtotalrange">Subtotalrange</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="subtotalrange" 
                                            placeholder="Subtotalrange" 
                                            required=""
                                            onChange={(e) => setPricerulesubtotalrange(e.target.value)}
                                        />
                                    </div>
                                    </Col> 
                                    </Row>                    
                                </ModalBody>
                                <ModalFooter>
                                    <Link href={'/'}><a className="btn-solid btn-custom"onClick={savepricerule} color="secondary">Save</a></Link>
                                    <Button className="btn-solid btn-custom" color="secondary" onClick={priceruletoggle}>Cancel</Button>
                                </ModalFooter>
                         </Modal>
                         <Modal isOpen={editpricerulemodal} toggle={editpriceruletoggle} centered>
                                <ModalHeader toggle={editpriceruletoggle}>Update pricerule</ModalHeader>
                                <ModalBody className="p-4">
                                <Row>
                                    <Col sm="4"> 
                                    <Input 
                                            type="hidden" 
                                            id="priceruleid" 
                                            value={editpriceruleid}
                                            required=""
                                            onChange={(e) => setEditPriceruletitle(e.target.value)}
                                        />
                                    <div className="form-group">
                                        <Label for="title">Title</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="title" 
                                            value={editpriceruletitle}
                                            placeholder="Title" 
                                            required=""
                                            onChange={(e) => setEditPriceruletitle(e.target.value)}
                                        />
                                    </div>
                                    </Col>
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="usagelimit">Usagelimit</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="usagelimit" 
                                            value={editpriceruleusagelimit}
                                            placeholder="Usagelimit" 
                                            required=""
                                            onChange={(e) => setEditPriceruleusagelimit(e.target.value)}
                                        />
                                    </div>                   
                                    </Col>
                                    <Col sm="4">                     
                                    <div className="form-group">
                                        <Label for="value">Value</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="value" 
                                            value={editpricerulevalue}
                                            placeholder="Value" 
                                            required=""
                                            onChange={(e) => setEditPricerulevalue(e.target.value)}
                                        />
                                    </div> 
                                    </Col>
                                    </Row>
                                    <Row>
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="valuetype">Valuetype</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="valuetype" 
                                            value={editpricerulevaluetype}
                                            placeholder="Valuetype" 
                                            required=""
                                            onChange={(e) => setEditPricerulevaluetype(e.target.value)}
                                        />
                                    </div>
                                    </Col> 
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="startat">Start at</Label> 
                                        <DatePicker className="form-control"dateFormat="yyyy-mm-dd" selected={startDate} value={editpricerulestartat} onChange={(date) => setEditPricerulestartat(date)} />
                                    </div>     
                                    </Col> 
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="endat">End at</Label> 
                                        <DatePicker className="form-control"dateFormat="yyyy-mm-dd" selected={startDate} value={editpriceruleendat} onChange={(date) => setEditPriceruleendat(date)} />
                
                                    </div> 
                                    </Col>  
                                    </Row> 
                                    <Row>
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="quantitypricerange">Quantitypricerange</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="quantitypricerange" 
                                            value={editpricerulequantitypricerange}
                                            placeholder="Quantitypricerange" 
                                            required=""
                                            onChange={(e) => setEditPricerulequantitypricerange(e.target.value)}
                                        />
                                    </div>
                                    </Col> 
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="shippingpricerange">shippingpricerange</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="shippingpricerange" 
                                            value={editpriceruleshippingpricerange}
                                            placeholder="shippingpricerange" 
                                            required=""
                                            onChange={(e) => setEditPriceruleshippingpricerange(e.target.value)}
                                        />
                                    </div>
                                    </Col> 
                                    <Col sm="4">
                                    <div className="form-group">
                                        <Label for="subtotalrange">Subtotalrange</Label> 
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="subtotalrange" 
                                            value={editpricerulesubtotalrange}
                                            placeholder="Subtotalrange" 
                                            required=""
                                            onChange={(e) => setEditPricerulesubtotalrange(e.target.value)}
                                        />
                                    </div>
                                    </Col> 
                                    </Row>                    
                                </ModalBody>
                                <ModalFooter>
                                    <Link href={'/'}><a className="btn-solid btn-custom"onClick={updatepricerule} color="secondary">Save</a></Link>
                                    <Button className="btn-solid btn-custom" color="secondary" onClick={editpriceruletoggle}>Cancel</Button>
                                </ModalFooter>
                         </Modal>
                         <Modal isOpen={deletepricerulemodal} toggle={deletepriceruletoggle} centered>
                            <ModalHeader toggle={deletepriceruletoggle}>Delete Pricerule</ModalHeader>
                            <ModalBody className="p-4">
                            <div className="form-group">
                                        <Input 
                                            type="hidden" 
                                            className="form-control" 
                                            id="editpriceruleid" 
                                            value={editpriceruleid}
                                            required=""
                                        />
                                    </div>

                        
                            </ModalBody>
                            <ModalFooter>
                                <Link href={'/'}><a className="btn-solid btn-custom"onClick={updatepricerule} color="secondary">Are you sure!</a></Link>
                                <Button className="btn-solid btn-custom" color="secondary" onClick={deletepriceruletoggle}>Cancel</Button>
                            </ModalFooter>
                        </Modal>
        </div>
    )
} 
export default Pricerulelist;