import React, { useEffect, useState } from 'react';
import Link from 'next/link';
import Select from 'react-select';
import {Input,Modal,ModalBody ,ModalFooter,ModalHeader, Button, Label } from 'reactstrap';
import { useRouter } from 'next/router'
import BootstrapTable from 'react-bootstrap-table-next'; //paginator
import filterFactory from 'react-bootstrap-table2-filter'; //paginator
import paginationFactory from 'react-bootstrap-table2-paginator';  //paginator
import axios from 'axios'
import { config } from '../../../config/main'

const Rolelist = (props) =>{

    const [columns, setColumns] = useState([{dataField: 'name', text: 'Rolename',sort: true},
    {
   dataField: "roleid",
   text: 'Action',
   formatter: (rowContent, row) => {
     return (
          <React.Fragment>
       <a  onClick={e => { e.persist(); editRole(row.id);}}><i class="fa fa-edit"></i></a>   
       <a  onClick={e => { e.persist(); deleteRole(row.id);}}><i class="fa fa-trash"></i></a>
       </React.Fragment>
     );
    }
    }]);
    const router = useRouter()
    const [roles, setRoles] = useState([]);
    const [roleid, setRoleid] = useState([]);
    const [rolemodal, setRolemodal] = useState(false);
    const roletoggle = () => setRolemodal(!rolemodal);
    const [name, setName] = useState();
    const [apipermissions, setApiermissions] = useState([]);
    const [selectedpermissions, setSelectedpermissions] = useState([]);
    //Add role

    const [editrolemodal, setEditrolemodal] = useState(false); //modal
    const editroletoggle = () => setEditrolemodal(!editrolemodal); //modal
    const [edtrolename, setEditrolename] = useState();
    const [edtrolepermissions, setEditrolepermissions] = useState([]);
    const [edtselectedpermissions, setEditSelectedpermissions] = useState([]);
    let url = config.API
    //  let token =config.Token
    function getpermissions(){
        try {
            const token=sessionStorage.getItem("token")
           
        axios({
            method: 'get',
            url: url+'/get-permissions',
            headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
            })
            .then(function (response) {
                let  getpermissions =  response.data.result;  
                setApiermissions(getpermissions);
            })
            .catch(function (response) {
                //handle error
                console.log(response);
            });
        } catch (err) {
            alert("failed")
        }
    }
  
    const handleSelect = function(selectedItems) {
        const selepermissions = [];
        for (let i=0; i<selectedItems.length; i++) {
            selepermissions.push(selectedItems[i].value);
        }
        setSelectedpermissions(selepermissions);
        console.log("choosedpermission"+selectedpermissions);
    }

    const handleSelectedit = function(edtselectedpermissions) {
        const selepermissionsedit = [];
        for (let i=0; i<edtselectedpermissions.length; i++) {
            selepermissionsedit.push(edtselectedpermissions[i].value);
        }
        setEditSelectedpermissions(selepermissionsedit);
    }
    const handleClose = () => setRolemodal(false);
    
    const saverole = async (e) => {
        e.preventDefault()
        if (name.length === 0) {
            alert("name field is required")            
            return 
        }     
        var sel=selectedpermissions;
        var n = sel.toString();
        console.log('sss '+n);
        var permissions = n.split(',');  
        try {    
            const token=sessionStorage.getItem("token")
            axios({
                method: 'post',
                url: url+'/create-role',
                data:JSON.stringify({ name,permissions }),
                headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
                })
                .then(function (response) {             
                    getroles();
                    handleClose();
                })
                .catch(function (response) {       
                });       
        } catch (err) {
        }
    }
    //End add role
    useEffect(() => {
        getroles()
        getpermissions();
      }, []);
     
      async function getroles() {
        try {
        const token=sessionStorage.getItem("token")
        axios({
            method: 'get',
            url: url+'/get-roles',
            headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
            })
            .then(function (response) {
                let  roles =  response.data.result;
                console.log(response);
              
                setRoles(roles);     
            })
            .catch(function (response) {
            }); 
        } catch (err) {
        }
      }
      const handleeditroleOpen = () => setEditrolemodal(true);
      const handleeditroleClose = () => setEditrolemodal(false);
     
    const editRole = (id)  => {
        try {
            const token=sessionStorage.getItem("token")
        axios({
            method: 'get',
            url: url+'/edit-role/'+id,
            headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
            })
            .then(function (response) {
                        let  roledetails = response.data.result;
                        let rolepermissions = roledetails.permissions;
                        if(rolepermissions != ''){
                            let ids = rolepermissions.map(function(item, i){ return item.value;   })  
                            const permissionsids =ids.toString().split(',');
                            setEditSelectedpermissions(permissionsids);   
                        }else{
                            const permissionsids='';
                            setEditSelectedpermissions(permissionsids);   
                        }
                        setRoleid(id);  
                        setEditrolename(roledetails.role.name);
                        setEditrolepermissions(rolepermissions);
                        handleeditroleOpen();
            })
            .catch(function (response) {
                console.log(response);
            });
        } catch (err) {
        }
     
    }
    const updaterole = async (e) => {
        e.preventDefault()
        if (edtrolename.length === 0) {
            alert("name field is required")            
            return 
        }     
        var esel=edtselectedpermissions;
        var n = esel.toString();
        var permission = n.split(',');  
        try {   
            const token=sessionStorage.getItem("token")
            axios({
                method: 'post',
                url: url+'/update-role',
                data:JSON.stringify({ edtrolename,permission,roleid}),
                headers: {'Content-Type': 'application/json' ,"Authorization":'Bearer '+token}
                })
                .then(function (response) {     
                    getroles();
                    handleeditroleClose();
                })
                .catch(function (response) {  
                });       
        } catch (err) {
        }
    }
    const deleteRole = (id) => {
        alert('delete role'+id);
        //router.push("/product/new")
    }
    return (
        <div>
        <h3> Roles</h3>
        <button className="btn btn-sm btn-solid m-3"onClick={roletoggle}>add role </button>
        <BootstrapTable   
        striped 
        hover  
        keyField='id'   
        dataField= "databasePkey"
        data={roles }   
        columns={columns }  
        pagination={ paginationFactory() }
        filter={ filterFactory() }/>
                        <Modal isOpen={rolemodal} toggle={roletoggle} centered>
                            <ModalHeader toggle={roletoggle}>Add new role</ModalHeader>
                            <ModalBody className="p-4">
                            <div className="form-group">
                                        <Label for="Role">Role Name</Label>
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="Role" 
                                            placeholder="Role" 
                                            required=""
                                            onChange={(e) => setName(e.target.value)}
                                        />
                                    </div>
                                   
                                    <div className="form-group">
                                        <Label for="permissions">Permissions</Label>
                                        <Select
    isMulti
    name="colors"
    options={apipermissions}
    onChange={handleSelect}
    className="basic-multi-select"
    classNamePrefix="select"
  />
                                    </div>
                            </ModalBody>
                            <ModalFooter>
                                <Link href={'/'}><a className="btn-solid btn-custom" color="secondary"onClick={saverole}>Save</a></Link>
                                <Button className="btn-solid btn-custom" color="secondary" onClick={roletoggle}>Cancel</Button>
                            </ModalFooter>
                        </Modal>
                        <Modal isOpen={editrolemodal} toggle={editroletoggle} centered>
                            <ModalHeader toggle={editroletoggle}>Edit role</ModalHeader>
                            <ModalBody className="p-4">
                            <div className="form-group"> 
                                        <Label for="Role">Role Name</Label>       
                                        <Input 
                                            type="text" 
                                            className="form-control" 
                                            id="Role" 
                                            value={edtrolename}
                                            placeholder="Role" 
                                            required=""
                                            onChange={(e) => setEditrolename(e.target.value)}
                                        />
                                    </div>
                                    
                                    <div className="form-group">
                                        <Label for="permissions">Permissions</Label>
                                        <Select
    isMulti
    defaultValue={edtrolepermissions}
    name="colors"
    options={apipermissions}
    onChange={handleSelectedit}
    className="basic-multi-select"
    classNamePrefix="select"
  />
                                    </div>
                            </ModalBody>
                            <ModalFooter>
                                <Link href={'/'}><a className="btn-solid btn-custom" color="secondary"onClick={updaterole}>Save</a></Link>
                                <Button className="btn-solid btn-custom" color="secondary" onClick={editroletoggle}>Cancel</Button>
                            </ModalFooter>
                        </Modal>
        </div>
        
    )
} 
export default Rolelist;